# coding: utf-8

"""
    Quantum Inspire 2

     **Sorting and Pagination of list endpoints**  The api provides sorting and pagination for list endpoints. The following parameters can be passed as query parameters to get sorted and paginated list.  - `latest`     - **Type**: Boolean.     - **Description**: Get the most recently created object. Defaults to False. - `sort_by`     - **Type**: String:     - **Description**: The field / column name to sort on. To reverse sort provide the field with a \"-\" sign. E.g. \"created_on\" for ascending order while \"-created_on\" in descending order. Defaults to \"id\". - `page_number`     - **Type**: Positive Integer     - **Description**: The page number for pagination. Defaults to 1. - `items_per_page`     - **Type**: Positive Integer.     - **Description**: The number of items per page for pagination. Defaults to 50. 

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt
from compute_api_client.models.algorithm_type import AlgorithmType
from compute_api_client.models.batch_job_status import BatchJobStatus
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class BatchJob(BaseModel):
    """
    BatchJob
    """ # noqa: E501
    id: StrictInt
    created_on: datetime
    status: BatchJobStatus
    user_id: StrictInt
    backend_type_id: StrictInt
    backend_id: Optional[StrictInt]
    queued_at: Optional[datetime]
    reserved_at: Optional[datetime]
    finished_at: Optional[datetime]
    job_ids: List[StrictInt]
    aggregated_algorithm_type: AlgorithmType
    __properties: ClassVar[List[str]] = ["id", "created_on", "status", "user_id", "backend_type_id", "backend_id", "queued_at", "reserved_at", "finished_at", "job_ids", "aggregated_algorithm_type"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of BatchJob from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # set to None if backend_id (nullable) is None
        # and model_fields_set contains the field
        if self.backend_id is None and "backend_id" in self.model_fields_set:
            _dict['backend_id'] = None

        # set to None if queued_at (nullable) is None
        # and model_fields_set contains the field
        if self.queued_at is None and "queued_at" in self.model_fields_set:
            _dict['queued_at'] = None

        # set to None if reserved_at (nullable) is None
        # and model_fields_set contains the field
        if self.reserved_at is None and "reserved_at" in self.model_fields_set:
            _dict['reserved_at'] = None

        # set to None if finished_at (nullable) is None
        # and model_fields_set contains the field
        if self.finished_at is None and "finished_at" in self.model_fields_set:
            _dict['finished_at'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of BatchJob from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "created_on": obj.get("created_on"),
            "status": obj.get("status"),
            "user_id": obj.get("user_id"),
            "backend_type_id": obj.get("backend_type_id"),
            "backend_id": obj.get("backend_id"),
            "queued_at": obj.get("queued_at"),
            "reserved_at": obj.get("reserved_at"),
            "finished_at": obj.get("finished_at"),
            "job_ids": obj.get("job_ids"),
            "aggregated_algorithm_type": obj.get("aggregated_algorithm_type")
        })
        return _obj


